import java.util.Enumeration;
import java.util.Hashtable;

public class CaseInsensitiveString
{
   String s;
  
   public CaseInsensitiveString (String s)
   {
      this.s = s;
   }
  
   public boolean equals (Object obj)
   {
      return (s.equalsIgnoreCase (obj.toString()));
   }
   
   public int hashCode()
   {
      return (s.toUpperCase().hashCode());
   }

   public String toString()
   {
      return (s);
   }

   public static void main (String[] args)
   {
      Hashtable hash = new Hashtable();

      CaseInsensitiveString cis = new CaseInsensitiveString ("abc");
      hash.put (cis, "value");

      cis = new CaseInsensitiveString ("ABC");
      String value = (String) hash.get (cis);
      System.out.println (cis + " maps to " + value);
   }
}
