import java.awt.*;
import javax.swing.*;

public class DataValidator extends JTextField
implements StatusListener
{
   public DataValidator()
   {
      setHorizontalAlignment (JTextField.RIGHT);

      // filter and validate the data
      Filter f = new NumericFilter (this);
      NumericValidator v = new NumericValidator();
      v.setRange (0, 100);
      v.addStatusListener (this);
      getDocument().addDocumentListener (v);
   }
   
   public void stateChanged (StatusEvent e)
   {
      if (e.getStatus())
         setBackground (Color.white);
      else
         setBackground (Color.pink);
   }
   
   public static void main (String[] args)
   {
      DataValidator dv = new DataValidator();
      JFrame frame = new JFrame ("Validator");
      frame.getContentPane().setLayout
        (new BorderLayout());
      frame.getContentPane().add
        (dv, BorderLayout.CENTER);
      frame.pack();
      frame.show();
   }
}
