package jwiley.effective;

import java.io.*;

public class BetterConcat
{
    public static void main(String args[]) throws IOException
    {
        if (args.length < 1)
        {
            System.out.println("USAGE: java jwiley.effective.BetterConcat filename");
            System.exit(1);
        }

        FileReader fr = new FileReader(args[0]);
        BufferedReader br = new BufferedReader(fr);
        long begin = System.currentTimeMillis();

        StringBuffer buf = new StringBuffer();
        String line = null;

        while ( (line = br.readLine()) != null)
        {
            if (line.startsWith("#") == false)
            {
                buf.append(line);
                buf.append('\n');
            }
        }

        long end = System.currentTimeMillis();
        long elapsed = end - begin;

        System.out.println("Elapsed Milliseconds: " + elapsed);
        System.out.println("# of chars in buf   : " + buf.length());
        fr.close();
    }
}
